block.h File Reference
`#include "av1/common/blockd.h"`
`#include "av1/common/entropymv.h"`
`#include "av1/common/entropy.h"`
`#include "av1/common/enums.h"`
`#include "av1/common/mvref_common.h"`
`#include "av1/encoder/enc_enums.h"`
`#include "av1/encoder/mcomp_structs.h"`
`#include "av1/encoder/partition_cnn_weights.h"`
`#include "av1/encoder/hash_motion.h"`

Go to the source code of this file.

## Data Structures

struct | SuperBlockEnc
| Superblock level encoder info. More...
struct | WinnerModeStats
| Stores the best performing modes. More...
struct | macroblock_plane
| Each source plane of the current macroblock. More...
struct | LV_MAP_COEFF_COST
| Costs for encoding the coefficients within a level. More...
struct | LV_MAP_EOB_COST
| Costs for encoding the eob. More...
struct | CB_COEFF_BUFFER
| Stores the transforms coefficients for the whole superblock. More...
struct | MB_MODE_INFO_EXT
| Extended mode info derived from mbmi. More...
struct | MB_MODE_INFO_EXT_FRAME
| Stores best extended mode information at frame level. More...
struct | MB_RD_INFO
| Inter-mode txfm results for a partition block. More...
struct | MB_RD_RECORD
| Hash records of the inter-mode transform results. More...
struct | COMP_RD_STATS
| Rdcost stats in compound mode. More...
struct | OBMCBuffer
| Contains buffers used to speed up rdopt for obmc. More...
struct | PALETTE_BUFFER
| Contains color maps used in palette mode. More...
struct | CompoundTypeRdBuffers
| Contains buffers used by av1_compound_type_rd(). More...
struct | PartitionSearchInfo
| Holds some parameters related to partitioning schemes in AV1. More...
struct | TxfmSearchParams
| Defines the parameters used to perform txfm search. More...
struct | TxfmSearchInfo
| Stores various encoding/search decisions related to txfm search. More...
struct | ModeCosts
| Holds the entropy costs for various modes sent to the bitstream. More...
struct | MvCosts
| Holds mv costs for encoding and motion search. More...
struct | IntraBCMVCosts
| Holds mv costs for intrabc. More...
struct | CoeffCosts
| Holds the costs needed to encode the coefficients. More...
struct | WARP_SAMPLE_INFO
| Holds the motion samples for warp motion model estimation. More...
struct | macroblock
| Encoder's parameters related to the current coding block. More...

## Macros

#define | MIN_TPL_BSIZE_1D 16
| Minimum linear dimension of a tpl block.
#define | MAX_TPL_BLK_IN_SB (MAX_SB_SIZE / MIN_TPL_BSIZE_1D)
| Maximum number of tpl block in a super block.
#define | RD_RECORD_BUFFER_LEN 8
| Number of txfm hash records kept for the partition block.
#define | MAX_TX_TYPE_PROB 1024
#define | TOP_INTER_TX_NO_SPLIT_COUNT 4
#define | COLOR_SENS_IDX(plane)
| Compute color sensitivity index for given plane.
#define | COLLECT_NONRD_PICK_MODE_STAT 0
| Enable timer statistics of mode search in non-rd.
#define | MAX_COMP_RD_STATS 64
| Number of compound rd stats.
#define | TOP_COMP_AVG_EST_RD_COUNT 5
| Maximum number of estimated RD Cost records for compound average.

## Typedefs

typedef struct macroblock_plane | MACROBLOCK_PLANE
| Each source plane of the current macroblock.
typedef struct macroblock | MACROBLOCK
| Encoder's parameters related to the current coding block.

## Detailed Description

Declares various structs used to encode the current partition block.

## Macro Definition Documentation

## MAX_TX_TYPE_PROB

#define MAX_TX_TYPE_PROB 1024

Maximum value taken by transform type probabilities

Referenced by encode_frame_internal().

## TOP_INTER_TX_NO_SPLIT_COUNT

#define TOP_INTER_TX_NO_SPLIT_COUNT 4

Maximum value of inter transform RD records.

## COLOR_SENS_IDX

#define COLOR_SENS_IDX | ( |  | plane | ) |

Value:
((plane) - 1)

Compute color sensitivity index for given plane.

Referenced by av1_nonrd_pick_inter_mode_sb(), and pick_sb_modes_nonrd().

## Typedef Documentation

## MACROBLOCK_PLANE

typedef struct macroblock_plane MACROBLOCK_PLANE

Each source plane of the current macroblock.

This struct also stores the txfm buffers and quantizer settings.

## MACROBLOCK

typedef struct macroblock MACROBLOCK

Encoder's parameters related to the current coding block.

This struct contains most of the information the encoder needs to encode the current coding block. This includes the src and pred buffer, a copy of the decoder's view of the current block, the txfm coefficients. This struct also contains various buffers and data used to speed up the encoding process.